using UnityEngine;
using UnityEngine.UI; //andr
using static CommunicationEvents;
using static StreamingAssetLoader;
using static UIconfig;

public class SaveNetwAddr_mobile : MonoBehaviour
{

    public GameObject SaveSlot1_B_GObj;
    public GameObject SaveSlot2_B_GObj;
    public GameObject SaveSlot3_B_GObj;
    public GameObject SaveSlot4_B_GObj;
    public GameObject SaveSlot5_B_GObj;

    private Color32 firstColB;
    private float transCol;
    private ColorBlock tempColB;

    public string Ip1_sup;
    public string Ip2_sup;
    public string Ip3_sup;
    public string Ip4_sup;
    public string Ip5_sup;


    void Start()
    {
        Ip1_sup = CommunicationEvents.IPslot1;
        Ip2_sup = CommunicationEvents.IPslot2;
        Ip3_sup = CommunicationEvents.IPslot3;
        Ip4_sup = CommunicationEvents.IPslot4;
        Ip5_sup = CommunicationEvents.IPslot5;


    }

    private void Update()
    {


        UpdateUI_3_f();
        UpdateUI_4_f();

        UpdateUI_5_f();
        UpdateUI_7_f();
        UpdateUI_8_f();
    }

    public void Refresh_pressed()
    {
        Ip1_sup = CommunicationEvents.IPslot1;
        Ip2_sup = CommunicationEvents.IPslot2;
        Ip3_sup = CommunicationEvents.IPslot3;
        Ip3_sup = CommunicationEvents.IPslot4;
        Ip3_sup = CommunicationEvents.IPslot5;
        //print("se" + Ip1_sup);

    }





    void UpdateUI_3_f()
    {
        //------------------------------------------------------------------------
        tempColB = SaveSlot1_B_GObj.GetComponent<Button>().colors;
        tempColB.pressedColor = colPressed;
        tempColB.selectedColor = colSelect;

        if (ServerSlots[ServerSlot.slot1].currentStatus == ServerStatus.offline)
        {
            tempColB.normalColor = colOffline;
            if (string.IsNullOrEmpty(CommunicationEvents.IPslot1))// || CommunicationEvents.IPslot1.Length < 1)
            {
                SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
            else
            {


                if (Ip1_sup.Equals(CommunicationEvents.IPslot1))
                {
                    SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 1 (Offline) \n" + CommunicationEvents.IPslot1;
                }
                else
                {
                    print("sss" + Ip1_sup.Equals(CommunicationEvents.IPslot1));
                    SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot1;
                }
            }
        }
        else
        {
            if (ServerSlots[ServerSlot.slot1].currentStatus == ServerStatus.online)
            {
                print("test" + Ip1_sup);
                if (Ip1_sup.Equals(CommunicationEvents.IPslot1))
                {
                    tempColB.normalColor = colOnline;
                    SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 1 (Online) \n" + CommunicationEvents.IPslot1;
                }
                else
                {
                    print("s3ss" + Ip1_sup.Equals(CommunicationEvents.IPslot1));
                    SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot1;
                    print("ww" + Ip1_sup);
                    print("we" + CommunicationEvents.IPslot1);

                }
            }
            else
            {
                tempColB.normalColor = colOffline;
                SaveSlot1_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
        }
        SaveSlot1_B_GObj.GetComponent<Button>().colors = tempColB;




    }




    void UpdateUI_4_f()
    {
        //-------------------------------------------------------------------------
        tempColB = SaveSlot2_B_GObj.GetComponent<Button>().colors;
        tempColB.pressedColor = colPressed;
        tempColB.selectedColor = colSelect;
        if (ServerSlots[ServerSlot.slot2].currentStatus == ServerStatus.offline)
        {
            tempColB.normalColor = colOffline;
            if (string.IsNullOrEmpty(CommunicationEvents.IPslot2))// || CommunicationEvents.IPslot2.Length<1)
            {
                SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
            else
            {
                if (Ip2_sup.Equals(CommunicationEvents.IPslot2))
                {
                    SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 2 (Offline) \n" + CommunicationEvents.IPslot2;
                }
                else
                {
                    SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot2;
                }
            }
        }
        else
        {
            if (ServerSlots[ServerSlot.slot2].currentStatus == ServerStatus.online)
            {
                if (Ip2_sup.Equals(CommunicationEvents.IPslot2))
                {
                    tempColB.normalColor = colOnline;
                    SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 2 (Online) \n" + CommunicationEvents.IPslot2;
                }
                else
                {
                    SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot2;

                }
            }
            else
            {
                tempColB.normalColor = colOffline;
                SaveSlot2_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
        }
        SaveSlot2_B_GObj.GetComponent<Button>().colors = tempColB;
    }


    void UpdateUI_5_f()
    {
        //---------------------------------------------------------------------------
        tempColB = SaveSlot3_B_GObj.GetComponent<Button>().colors;
        tempColB.pressedColor = colPressed;
        tempColB.selectedColor = colSelect;
        if (ServerSlots[ServerSlot.slot3].currentStatus == ServerStatus.offline)
        {
            tempColB.normalColor = colOffline;
            if (string.IsNullOrEmpty(CommunicationEvents.IPslot3))// || CommunicationEvents.IPslot3.Length < 1)
            {
                SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
            else
            {
                if (Ip3_sup.Equals(CommunicationEvents.IPslot3))
                {
                    SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 3 (Offline) \n" + CommunicationEvents.IPslot3;
                }
                else
                {
                    SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot3;
                }
            }
        }
        else
        {
            if (ServerSlots[ServerSlot.slot3].currentStatus == ServerStatus.online)
            {
                if (Ip3_sup.Equals(CommunicationEvents.IPslot3))
                {
                    tempColB.normalColor = colOnline;
                    SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 3 (Onnline) \n" + CommunicationEvents.IPslot3;
                }
                else
                {
                    SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot3;

                }
            }
            else
            {
                tempColB.normalColor = colOffline;
                SaveSlot3_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
        }
        SaveSlot3_B_GObj.GetComponent<Button>().colors = tempColB;

    }

    void UpdateUI_7_f()
    {
        //---------------------------------------------------------------------------
        tempColB = SaveSlot4_B_GObj.GetComponent<Button>().colors;
        tempColB.pressedColor = colPressed;
        tempColB.selectedColor = colSelect;
        if (ServerSlots[ServerSlot.slot4].currentStatus == ServerStatus.offline)
        {
            tempColB.normalColor = colOffline;
            if (string.IsNullOrEmpty(CommunicationEvents.IPslot4))// || CommunicationEvents.IPslot3.Length < 1)
            {
                SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
            else
            {
                if (Ip4_sup.Equals(CommunicationEvents.IPslot4))
                {
                    SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 4 (Offline) \n" + CommunicationEvents.IPslot4;
                }
                else
                {
                    SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot4;
                }
            }
        }
        else
        {
            if (ServerSlots[ServerSlot.slot1].currentStatus == ServerStatus.online)
            {
                if (Ip4_sup.Equals(CommunicationEvents.IPslot4))
                {
                    tempColB.normalColor = colOnline;
                    SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 4 (Online) \n" + CommunicationEvents.IPslot4;
                }
                else
                {
                    SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot4;

                }
            }
            else
            {
                tempColB.normalColor = colOffline;
                SaveSlot4_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
        }
        SaveSlot4_B_GObj.GetComponent<Button>().colors = tempColB;

    }

    void UpdateUI_8_f()
    {
        //---------------------------------------------------------------------------
        tempColB = SaveSlot3_B_GObj.GetComponent<Button>().colors;
        tempColB.pressedColor = colPressed;
        tempColB.selectedColor = colSelect;
        if (ServerSlots[ServerSlot.slot5].currentStatus == ServerStatus.offline)
        {
            tempColB.normalColor = colOffline;
            if (string.IsNullOrEmpty(CommunicationEvents.IPslot5))// || CommunicationEvents.IPslot3.Length < 1)
            {
                SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
            else
            {
                if (Ip5_sup.Equals(CommunicationEvents.IPslot5))
                {
                    SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 5 (Offline) \n" + CommunicationEvents.IPslot5;
                }
                else
                {
                    SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot5;
                }
            }
        }
        else
        {
            if (ServerSlots[ServerSlot.slot5].currentStatus == ServerStatus.offline)
            {
                if (Ip5_sup.Equals(CommunicationEvents.IPslot5))
                {
                    tempColB.normalColor = colOnline;
                    SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer 5 (Online) \n" + CommunicationEvents.IPslot5;
                }
                else
                {
                    SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \nServer " + CommunicationEvents.IPslot5;

                }
            }
            else
            {
                tempColB.normalColor = colOffline;
                SaveSlot5_B_GObj.GetComponentInChildren<Text>().text = "OVERWRITE: \n< empty >";
            }
        }
        SaveSlot5_B_GObj.GetComponent<Button>().colors = tempColB;

    }

    /// <summary>
    /// All the Functions below can be consolidated into this one. 
    /// But changing every button to do so is annoying, and I am refactoring other stuff.
    /// </summary>
    /// <param name="slot"> The ServerSlot to replace with the new IP </param>
    public void SaveIntoSlot(ServerSlot slot)
    {
        ServerSlots[slot].domain = NewIP;
        //CommunicationEvents.ServerAdress = "http://" +  CommunicationEvents.ServerAddress1;
        StartCoroutine(ServerSlots[slot].UpdateServerStatus());
        Update();
        NetworkJSON_Save();
        Refresh_pressed();

        //CSform.CheckIPAdr();

    }

    public void Slot1_s()
    {
        CommunicationEvents.IPslot1 = CommunicationEvents.NewIP;
        //CommunicationEvents.ServerAdress = "http://" +  CommunicationEvents.ServerAddress1;
        Update();
        StartCoroutine(ServerSlots[ServerSlot.slot1].UpdateServerStatus());
        NetworkJSON_Save();
        Refresh_pressed();

        //CSform.CheckIPAdr();

    }

    public void Slot2_s()
    {

        //CommunicationEvents.ServerAdress = "http://" +  CommunicationEvents.ServerAddress2;
        CommunicationEvents.IPslot2 = CommunicationEvents.NewIP;
        Update();
        StartCoroutine(ServerSlots[ServerSlot.slot2].UpdateServerStatus());
        NetworkJSON_Save();
        Refresh_pressed();
        //CSform.CheckIPAdr();


    }

    public void Slot3_s()
    {
        //CheckServer ani = new CheckServer();//= obj.AddComponent<CheckServer>();
        // ani.StartCheck();
        CommunicationEvents.IPslot3 = CommunicationEvents.NewIP;
        Update();
        StartCoroutine(ServerSlots[ServerSlot.slot3].UpdateServerStatus());
        Refresh_pressed();

        NetworkJSON_Save();
        //CSform.CheckIPAdr();
    }

    public void Slot4_s()
    {
        //CheckServer ani = new CheckServer();//= obj.AddComponent<CheckServer>();
        // ani.StartCheck();
        CommunicationEvents.IPslot4 = CommunicationEvents.NewIP;
        Update();
        StartCoroutine(ServerSlots[ServerSlot.slot4].UpdateServerStatus());
        Refresh_pressed();

        NetworkJSON_Save();
        //CSform.CheckIPAdr();
    }

    public void Slot5_s()
    {
        //CheckServer ani = new CheckServer();//= obj.AddComponent<CheckServer>();
        // ani.StartCheck();
        CommunicationEvents.IPslot5 = CommunicationEvents.NewIP;
        Update();
        StartCoroutine(ServerSlots[ServerSlot.slot5].UpdateServerStatus());
        Refresh_pressed();

        NetworkJSON_Save();
        //CSform.CheckIPAdr();
    }
}

















